package com.tashow.cloud.tradeapi.enums.aftersale;

import com.tashow.cloud.common.core.ArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;
import java.util.Collection;

import static cn.hutool.core.util.ArrayUtil.firstMatch;

/**
 * 售后状态的枚举
 *
 * <a href="https://www.processon.com/view/link/63731a270e3e742ce7b7c194">状态流转</a>
 *
 * @author 芋道源码
 */
@AllArgsConstructor
@Getter
public enum AfterSaleStatusEnum implements ArrayValuable<Integer> {

    APPLY(10,"等待审核", ""), // 有赞的状态提示：退款申请待商家处理
    SELLER_AGREE(20, "审核通过", ""), // 有赞的状态提示：请退货并填写物流信息
    BUYER_DELIVERY(30,"已完成", ""), // 有赞的状态提示：退货退款申请待商家处理
    WAIT_REFUND(40, "已取消", ""), // 有赞的状态提示：无（有赞无该状态）
    COMPLETE(50, "已拒绝", ""), // 有赞的状态提示：退款成功

    ;


    public static final Integer[] ARRAYS = Arrays.stream(values()).map(AfterSaleStatusEnum::getStatus).toArray(Integer[]::new);

    /**
     * 进行中的售后状态
     *
     * 不包括已经结束的状态
     */
    public static final Collection<Integer> APPLYING_STATUSES = Arrays.asList(
            APPLY.getStatus(),
            SELLER_AGREE.getStatus(),
            BUYER_DELIVERY.getStatus(),
            WAIT_REFUND.getStatus()
    );

    /**
     * 状态
     */
    private final Integer status;
    /**
     * 状态名
     */
    private final String name;
    /**
     * 操作内容
     *
     * 目的：记录售后日志的内容
     */
    private final String content;

    @Override
    public Integer[] array() {
        return ARRAYS;
    }

    public static AfterSaleStatusEnum valueOf(Integer status) {
        return firstMatch(value -> value.getStatus().equals(status), values());
    }

}
